From 131a48176af53d9909b67c285a1147a49a9d343b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?S=C3=A9bastien=20Toque?= <xilasz@gmail.com>
Date: Mon, 12 Sep 2011 23:19:18 +0200
Subject: [PATCH 2/2] amem: add channel mapping

---
 modules/audio_output/amem.c |   44 +++++++++++++++++++++++++++++++++++++++++-
 1 files changed, 42 insertions(+), 2 deletions(-)

diff --git a/modules/audio_output/amem.c b/modules/audio_output/amem.c
index 02dc44d..e1df86b 100644
--- a/modules/audio_output/amem.c
+++ b/modules/audio_output/amem.c
@@ -143,12 +143,52 @@ static int Open (vlc_object_t *obj)
         goto error;
 
     /* TODO: amem-format */
-    /* FIXME/TODO channel mapping */
-    if (strcmp(format, "S16N") || aout->format.i_channels != channels)
+    if (strcmp(format, "S16N"))
     {
         msg_Err (aout, "format not supported");
         goto error;
     }
+
+    /* channel mapping */
+    switch( channels )
+    {
+        case AOUT_VAR_MONO:
+            aout->format.i_physical_channels = AOUT_CHAN_CENTER;
+            break;
+        case AOUT_VAR_2F2R:
+            aout->format.i_physical_channels
+                = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT
+                | AOUT_CHAN_REARLEFT | AOUT_CHAN_REARRIGHT;
+            break;
+        case AOUT_VAR_3F2R:
+            aout->format.i_physical_channels
+                = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT | AOUT_CHAN_CENTER
+                | AOUT_CHAN_REARLEFT | AOUT_CHAN_REARRIGHT;
+            break;
+        case AOUT_VAR_5_1:
+            aout->format.i_physical_channels
+                = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT | AOUT_CHAN_CENTER
+                | AOUT_CHAN_REARLEFT | AOUT_CHAN_REARRIGHT
+                | AOUT_CHAN_LFE;
+            break;
+        case AOUT_VAR_6_1:
+            aout->format.i_physical_channels
+                = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT | AOUT_CHAN_CENTER
+                | AOUT_CHAN_REARCENTER
+                | AOUT_CHAN_MIDDLELEFT | AOUT_CHAN_MIDDLERIGHT
+                | AOUT_CHAN_LFE;
+            break;
+        case AOUT_VAR_7_1:
+            aout->format.i_physical_channels
+                = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT | AOUT_CHAN_CENTER
+                | AOUT_CHAN_REARLEFT | AOUT_CHAN_REARRIGHT
+                | AOUT_CHAN_MIDDLELEFT | AOUT_CHAN_MIDDLERIGHT
+                | AOUT_CHAN_LFE;
+            break;
+        default: /* AOUT_VAR_STEREO */
+            aout->format.i_physical_channels = AOUT_CHAN_LEFT | AOUT_CHAN_RIGHT;
+    }
+
     aout->format.i_format = VLC_CODEC_S16N;
     aout->format.i_rate = rate;
 
-- 
1.7.4.1

